<?php

namespace Drupal\tid_to_description;

use Drupal\taxonomy\Entity\Term;
use Twig_Extension;
use Twig_SimpleFunction;

/**
 * Class TwigExtension.
 *
 * @package Drupal\tid_to_description
 */
class TidToDescriptionTwigExtension extends Twig_Extension {

  /**
   * {@inheritdoc}
   */
  public function getDescription() {
    return 'tid_to_description';
  }

  /**
   * {@inheritdoc}
   */
  public function getFunctions() {
    return [
      new Twig_SimpleFunction('td', [$this, 'getTermDescription']),
    ];
  }

  /**
   * {@inheritdoc}
   */
  public function getTermDescription($tid) {
    $tid = '' . $tid;
    $term = Term::load($tid);
    if ($term) {
      $language = \Drupal::languageManager()->getCurrentLanguage()->getId();
      $translated_term = \Drupal::service('entity.repository')
        ->getTranslationFromContext($term, $language);
      return $translated_term->getDescription();
    }

    return '';
  }

}
